<template>
  <div
    :class="{
      'grid grid-cols-6 gap-4':
        (allowCompany && !isProviderGames1) ||
        (!allowCompany && slot && !isBK8Theme),
    }"
  >
    <div v-if="slot && isBK8Theme" class="entry__buttons-container p-6 mb-6">
      <div class="entry__buttons rounded-lg">
        <EntryButton
          v-for="(game, index) in _.orderBy(
            _.orderBy(providers, 'DropDownLabel'),
            'displayOrder'
          )"
          :key="index"
          :is-active="game.IsActive"
          :logo="getProviderLogo(game.DropDownLabel)"
          :is-hot="game.IsPromotion"
          :is-new="game.IsNew"
          :title="game.DropDownLabel"
          :text="game.GameProviderDisplayName"
          :use-primary-color="isThemeColorUsePrimaryColor"
          @click="onDropDownItemClicked(game)"
        />
      </div>
    </div>
    <div
      v-if="
        (allowCompany && !isProviderGames1) ||
        (!allowCompany && slot && !isBK8Theme)
      "
      class="col-span-1 game-filter-bg rounded-lg mb-10 px-4 divide-y"
      :class = "isMainTheme ? 'divide-white' : 'divide-[#243c5a]'"
    >
      <div
        v-for="(prover, index) in _.orderBy(
          _.orderBy(providers, 'DropDownLabel'),
          'displayOrder'
        )"
        :key="index"
      >
        <div
          class="menu-sitebar text-sm py-4 flex gap-2 justify-between items-center h-[56px]"
        >
          <div
            class="cursor-pointer text-xs"
            :class="[
              `${prover.IsActive ? activeColor : ''}`,
              {
                'opacity-[0.4] pointer-events-none grayscale-[1]':
                  prover.IsMaintain,
              },
            ]"
            @click="onDropDownItemClicked(prover)"
          >
            {{ prover.GameProviderDisplayName }}
          </div>
          <div class="flex flex-col gap-1">
            <div v-if="prover.IsHot">
              <img
                class="w-[48px] h-[16px]"
                :src="getAssetImage('assets/theme/common/icon/hot_icon.svg')"
              />
            </div>
            <div v-if="prover.IsNew">
              <img
                class="w-[48px] h-[16px]"
                :src="getAssetImage('assets/theme/common/icon/new_icon.svg')"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
    <div
      :class="{
        'col-span-5 mb-10':
          (allowCompany && !isProviderGames1) || (!allowCompany && slot),
      }"
    >
      <div class="relative">
        <div
          class="menu-main-content flex items-center game-filter game-filter-bg rounded-lg relative overflow-hidden justify-between pr-4"
        >
          <div
            v-for="(item, idx) in gameMenuForDisplay"
            :key="idx"
            class="flex items-center"
          >
            <div
              v-for="(menu, index) in item.Menus"
              :key="index"
              :class="`cursor-pointer game-tab-menu ${
                menu.IsActive ? 'active-tab' : ''
              }`"
              @mouseenter="
                (event) => openGameProviderToolTip(menu.Label, event)
              "
              @mouseleave="closeGameProviderToolTip(menu.Label)"
            >
              <el-tooltip
                :disabled="
                  menu.DropDownMenus.length === 0 || menu.Label === 'Provider'
                "
                popper-class="game-drop-down"
                effect="light"
              >
                <div
                  v-if="
                    (allowCompany && !isProviderGames1) ||
                    (!allowCompany && slot)
                  "
                  v-show="
                    menu.Label.toLowerCase().replace(' ', '_') !== 'provider'
                  "
                  class="items-center px-3 py-4 w-fit"
                  @click="onGameTabClicked(menu)"
                >
                  <div class="flex items-center justify-center">
                    <svg-icon
                      :svg-name="`icon-${menu.Label.toLowerCase().replace(
                        ' ',
                        '-'
                      )}`"
                      class="icon mr-2.5"
                    />

                    <span class="whitespace-nowrap fc-text">{{
                      $t(menu.Label.toLowerCase().replace(" ", "_"))
                    }}</span>
                  </div>
                </div>
                <div
                  v-else
                  class="items-center px-3 py-4 w-fit"
                  @click="onGameTabClicked(menu)"
                >
                  <div class="flex items-center justify-center">
                    <svg-icon
                      :svg-name="`icon-${menu.Label.toLowerCase().replace(
                        ' ',
                        '-'
                      )}`"
                      class="icon mr-2.5"
                    />
                    <span class="whitespace-nowrap fc-text">{{
                      $t(menu.Label.toLowerCase().replace(" ", "_"))
                    }}</span>
                  </div>
                </div>
                <template #content>
                  <div class="p-[10px] game-filter-bg drop-content gap-2">
                    <div
                      v-for="(dropdown, i) in _.orderBy(
                        _.orderBy(menu.DropDownMenus, 'DropDownLabel'),
                        'displayOrder'
                      )"
                      :key="i"
                      :class="`drop-down-list ${
                        dropdown.IsActive ? 'active' : ''
                      } ${
                        dropdown.IsMaintain
                          ? 'opacity-[0.4] pointer-events-none grayscale-[1]'
                          : ''
                      }`"
                    >
                      <div
                        class="flex items-center justify-between gap-2 cursor-pointer"
                        @click="onDropDownItemClicked(dropdown)"
                      >
                        <div class="relative flex items-center">
                          <SvgIcon
                            v-if="
                              menu.Label.toLowerCase().replace(' ', '_') !==
                              'provider'
                            "
                            class="w-[25px] h-[25px]"
                            :svg-name="
                              dropdown.DropDownLabel.toLocaleLowerCase()
                            "
                          />
                          <img
                            v-else
                            class="drop-down-icon"
                            :src="dropdown.DropDownLogoPath"
                          />
                          <div
                            v-if="dropdown.IsMaintain"
                            class="absolute top-[1px]"
                          >
                            <img
                              :src="
                                getAssetImage(
                                  'assets/theme/common/icon/icon_maintainance.png'
                                )
                              "
                            />
                          </div>

                          <span
                            :class="`${
                              dropdown.IsActive
                                ? 'fc-primary px-1.5'
                                : 'whitespace-nowrap'
                            }`"
                          >
                            {{ $t(String(dropdown.DropDownLabel)) }}
                          </span>
                        </div>
                        <div class="flex items-center">
                          <span v-if="dropdown.IsNew" class="is-new">
                            <img
                              :src="
                                getAssetImage(
                                  'assets/theme/common/icon/new_icon.svg'
                                )
                              "
                            />
                          </span>
                          <span
                            v-if="dropdown.IsPromotion"
                            class="is-promotion"
                            >{{ IsPromotionText }}</span
                          >
                        </div>
                      </div>
                    </div>
                  </div>
                </template>
              </el-tooltip>
            </div>
          </div>
          <form
            v-if="gameMenuForDisplay.some((g) => g.IsSearchBox && g.IsVisible)"
            class="flex items-center search-game-form absolute right-4"
            @submit.prevent="handleGameSearch"
          >
            <el-button
              v-if="!isShowSearchBox"
              style="padding: 8px 12px; margin-left: 8px"
              class="button--t4 whitespace-nowrap h-[40px] search-button uppercase"
              type="primary"
              @click="onHideShowSearchBox"
            >
              <font-awesome-icon icon="search" class="w-4 h-4 pr-1" />
              {{ $t("search") }}
            </el-button>
            <div v-if="isShowSearchBox" class="search-box-wrapper z-10">
              <el-input
                v-model="searchModel"
                class="search-box font-normal absolute right-0"
                :placeholder="$t('Search All Games')"
                @input="searching"
              >
              </el-input>
            </div>
            <el-button
              v-if="isShowSearchBox"
              id="game-search-submit-button"
              style="padding: 8px 12px;; margin-left: 8px"
              class="button--t4 whitespace-nowrap h-[40px] search-button uppercase z-20"
              type="primary"
              native-type="submit"
            >
              <font-awesome-icon icon="search" class="w-4 h-4 pr-1" />
              {{ $t("search") }}
            </el-button>
          </form>
        </div>
        <game-entry-m-game-provider-tool-tip
          :tool-tip-x-location="providerToolTipLocation"
          :is-promotion-text="IsPromotionText"
          :is-game-provider-tool-tip-visible="isGameProviderToolTipVisible"
          :game-menu-for-display="gameMenuForDisplay"
          @open-tool-tip="openGameProviderToolTip"
          @close-tool-tip="closeGameProviderToolTip"
          @drop-down-click="onDropDownItemClicked"
        />
      </div>
      <slot name="slotProp" />
    </div>
  </div>
</template>
<script lang="ts">
import _ from "lodash-es";
import {
  computed,
  defineComponent,
  onMounted,
  PropType,
  Ref,
  ref,
  watchEffect,
} from "vue";
import { Search } from "@element-plus/icons-vue";
import EntryButton from "../theme/desktop/bk8/components/EntryButton.client.vue";
import {
  GameEntryMenu,
  IGameEntryMenu,
  TabGameDropDownMenus,
  TabGameMenu,
} from "@/models/gameEntryFilter";
import { GameFilterRequest } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import { store } from "~~/store";
import textHelper from "~~/utils/formatHelpers/textFormatHelper";

export default defineComponent({
  name: "GameEntryFilter",
  components: {
    EntryButton,
    Search,
  },
  props: {
    menus: {
      type: Array as PropType<IGameEntryMenu[]>,
      default: () => [],
    },
    search: {
      type: String,
      default: "",
    },
    IsNewText: {
      type: String,
      default: "New",
    },
    IsPromotionText: {
      type: String,
      default: "Promo",
    },
    isVerticalTabContent: {
      type: Boolean,
      default: false,
    },
    activeColor: {
      type: String,
      default: "text-primary",
    },
  },
  emits: ["onFilterClicked", "update:search", "searchGames"],
  setup(props, { emit, slots }) {
    const route = useRoute();
    const router = useRouter();
    const { getAssetImage, allowCompany } = commonHelper;
    const gameMenuForDisplay: Ref<GameEntryMenu[]> = ref<GameEntryMenu[]>(
      props.menus.map(
        (item) => new GameEntryMenu(item, route.query.f === undefined)
      )
    );
    const isRemovedActive = ref(false);
    const lastRequest = ref({} as GameFilterRequest);
    const prevActiveaTab: Ref<TabGameMenu> = ref<TabGameMenu>(
      {} as TabGameMenu
    );
    const getPrevActiveTab = () => {
      gameMenuForDisplay.value.forEach((item) => {
        if (item.Menus.length) {
          item.Menus.forEach((menu) => {
            if (
              lastRequest.value.Type &&
              lastRequest.value.Type === menu.Label
            ) {
              prevActiveaTab.value = _.cloneDeep(menu);
              prevActiveaTab.value.IsActive = true;
            }
          });
        }
      });
    };
    const isShowSearchBox = ref(false);
    const searchModel = ref(props.search);
    const isGameProviderToolTipVisible = ref(false);
    const isLeaveToolTip = ref(true);
    const providerToolTipLocation = ref("0px");
    const searching = (e: any) => {
      if (e && !isRemovedActive.value) {
        getPrevActiveTab();
        removeActive();
        isRemovedActive.value = true;
      } else if (!e) {
        handleGameSearch();
      }
      emit("update:search", searchModel.value);
    };

    const removeActive = () => {
      gameMenuForDisplay.value.forEach((item) => {
        if (item.Menus.length) {
          item.Menus.forEach((menu) => {
            menu.IsActive = false;
            if (menu.DropDownMenus.length) {
              menu.DropDownMenus.forEach((dropdown) => {
                dropdown.IsActive = false;
              });
            }
          });
        }
      });
    };
    if (route.query.Type !== undefined && route.query.Type !== null && route.query.Type !== "") {
      removeActive();
      const findMenu = gameMenuForDisplay.value[0].Menus.find(item => item.Label === route.query.Type);
      if (findMenu?.IsActive !== undefined) {
        findMenu.IsActive = true;
      }
      if (route.query.Type === "Game Type" && findMenu?.DropDownMenus !== undefined) {
        const findDropdownLabel = findMenu.DropDownMenus.find(item => item.DropDownLabel === route.query.Value);
        if (findDropdownLabel?.IsActive !== undefined) {
          findDropdownLabel.IsActive = true;
        }
      }
    }
    const activateGameTabWithDropDown = (
      param: TabGameDropDownMenus
    ): string => {
      let result = "";
      gameMenuForDisplay.value.forEach((item) => {
        if (item.Menus.length) {
          item.Menus.forEach((menu) => {
            if (menu.DropDownMenus.includes(param)) {
              menu.IsActive = true;
              result = menu.Label;
            }
          });
        }
      });
      return result;
    };
    const onDropDownItemClicked = (param: TabGameDropDownMenus) => {
      isShowSearchBox.value = false;
      removeActive();
      const request: GameFilterRequest = {
        Type: activateGameTabWithDropDown(param),
        Value: param.DropDownLabel,
      };
      lastRequest.value = request;
      getPrevActiveTab();
      param.IsActive = true;
      searchModel.value = "";
      router.replace(`/games/${request.Value}`);
      emit("onFilterClicked", request);
      emit("update:search", "");
    };
    const isClickGameTab = ref(false);
    const onGameTabClicked = (param: TabGameMenu) => {
      isClickGameTab.value = true;
      isShowSearchBox.value = false;
      if (param.DropDownMenus.length === 0) {
        const request: GameFilterRequest = {
          Type: param.Label,
          Value: "",
        };
        lastRequest.value = request;
        removeActive();
        param.IsActive = true;
        getPrevActiveTab();
        searchModel.value = "";
        router.replace("/games");
        emit("onFilterClicked", request);
        emit("update:search", "");
      }
    };
    const handleGameSearch = () => {
      isShowSearchBox.value = !isShowSearchBox.value;
      if (!searchModel.value) {
        gameMenuForDisplay.value.forEach((item) => {
          item.Menus.forEach((menu) => {
            if (
              menu.Label.toLocaleLowerCase() ===
              prevActiveaTab.value.Label.toLowerCase()
            ) {
              menu.IsActive = true;
              if (
                menu.DropDownMenus.length !== 0 &&
                prevActiveaTab.value.DropDownMenus.length !== 0
              ) {
                menu.DropDownMenus.forEach((dropdown) => {
                  if (
                    dropdown.DropDownLabel ===
                    prevActiveaTab.value.DropDownMenus[0].DropDownLabel
                  ) {
                    dropdown.IsActive = true;
                  }
                });
              }
            }
          });
        });
        isRemovedActive.value = false;
        emit("onFilterClicked", lastRequest.value);
      }
      emit("searchGames");
    };
    const openGameProviderToolTip = (label: string, mouseLocation?: any) => {
      if (label.toLowerCase() === "provider") {
        isGameProviderToolTipVisible.value = true;
        isLeaveToolTip.value = false;
        if (mouseLocation !== null && mouseLocation !== undefined) {
          const boxWidth = mouseLocation.target.getBoundingClientRect().width;
          providerToolTipLocation.value = `${
            mouseLocation.target.offsetLeft + boxWidth / 2
          }px`;
        }
      }
    };
    const closeGameProviderToolTip = (label: string) => {
      if (label.toLowerCase() === "provider") {
        isLeaveToolTip.value = true;
        setTimeout(() => {
          if (isLeaveToolTip.value) {
            isGameProviderToolTipVisible.value = false;
          }
        }, 400);
      }
    };
    watchEffect(() => {
      if (route.params.filter) {
        const paramFilter = route.params.filter;
        if (props.search) {
          removeActive();
          return;
        }
        removeActive();
        gameMenuForDisplay.value.forEach((item) => {
          if (item.Menus.length) {
            item.Menus.forEach((menu) => {
              if (
                menu.DropDownMenus.some(
                  (ddm) =>
                    ddm.DropDownLabel.trim() === paramFilter.toString().trim()
                )
              ) {
                menu.IsActive = true;
                menu.DropDownMenus.forEach((dropdown) => {
                  if (
                    dropdown.DropDownLabel.trim() ===
                    paramFilter.toString().trim()
                  ) {
                    dropdown.IsActive = true;
                  }
                });
              }
            });
          }
        });
      }
    });

    const checkActive = (filterQuery: any) => {
      removeActive();
      gameMenuForDisplay.value.forEach((menus) => {
        menus.Menus.forEach((menu) => {
          if (menu.Label !== filterQuery) return;
          menu.IsActive = true;
          const request: GameFilterRequest = {
            Type: menu.Label,
            Value: menu.Label,
          };
          lastRequest.value = request;
          emit("onFilterClicked", request);
        });
      });
    };

    onMounted(() => {
      const filterQuery = route.query.f;
      if (filterQuery !== undefined) {
        checkActive(filterQuery);
        return;
      }
      if (filterQuery === undefined || !route.params.filter) {
        lastRequest.value = {
          Type: gameMenuForDisplay.value[0].Menus[0].Label,
          Value: "",
        };
        getPrevActiveTab();
        return;
      }
      checkActive(filterQuery);
    });
    watch(
      () => route.query,
      () => {
        if (!isClickGameTab.value) {
          gameMenuForDisplay.value.forEach((menus) => {
            menus.Menus.forEach((menu) => {
              if (menu.Label.toLowerCase() === route.query.f) {
                onGameTabClicked(menu);
              }
            });
          });
        }
        if (isClickGameTab.value) isClickGameTab.value = false;
      },
      { deep: true, immediate: true }
    );
    const providers = computed(
      () =>
        gameMenuForDisplay.value
          .find((x) => x.Theme === "common")
          ?.Menus.find(
            (item) => item.Label.toLowerCase().replace(" ", "_") === "provider"
          )?.DropDownMenus
    );
    const slot = slots.slotProp;
    const isBK8Theme = computed(() => store.state.selectedThemeName === "bk8");
    const isMainTheme = computed(
      () => store.state.selectedThemeName === "main"
    );
    const { convertString } = textHelper;
    const getProviderLogo = (providerName: string): string => {
      try {
        const fileName = `provider_logo_${convertString(
          providerName,
          true
        )}.png`;
        return getAssetImage(
          `assets/theme/bk8/desktop/logos/providers/${fileName}`
        );
      } catch (error) {
        return "";
      }
    };
    const themeProperties =
      store.state.companyThemePropertiesFromApi.ThemeProperties;
    const isThemeColorUsePrimaryColor = computed(() => {
      const themeColor = themePropertyHelper.getSingleThemeProperty(
        themeProperties,
        "theme_color"
      ).Text;
      return ["bk8_green"].includes(themeColor);
    });
    const isProviderGames1 = ref(false);
    themeProperties.forEach((property) => {
      if (property.Text === "Provider_type_games_1") {
        isProviderGames1.value = true;
      }
    });
    const onHideShowSearchBox = () => {
      isShowSearchBox.value = !isShowSearchBox.value;
    };
    return {
      gameMenuForDisplay,
      searching,
      searchModel,
      onDropDownItemClicked,
      onGameTabClicked,
      getAssetImage,
      providers,
      slot,
      _,
      isBK8Theme,
      isMainTheme,
      isProviderGames1,
      getProviderLogo,
      isThemeColorUsePrimaryColor,
      isRemovedActive,
      handleGameSearch,
      isShowSearchBox,
      onHideShowSearchBox,
      openGameProviderToolTip,
      closeGameProviderToolTip,
      isGameProviderToolTipVisible,
      providerToolTipLocation,
      allowCompany,
    };
  },
});
</script>
<style lang="scss">
:root {
  --gf-background-color: var(--primary);
  --gf-text-color: var(--textBtn);
  --gf-text-active-color: rgb(93, 240, 244);
  --game-tab-img-size: 20px;
  --tab-font-size: var(--font-size);
  --tab-item-width: 100px;

  --search-width: 200px;
  --search-height: 32px;
  --search-font-size: var(--font-size);
  --search-box-radius: calc(var(--search-height) / 2);

  --dropdown-min-width: 220px;
  --dropdown-font-size: var(--font-size);
  --dropdown-text-color: var(--textBtn);
  --new-background-color: var(--failure);
  --new-text-color: var(--textBtn);
  --new-font-size: 9px;
  --promotion-background-color: var(--secondary);
  --promotion-text-color: var(--textBtn);
  --promotion-font-size: 9px;
  --dropdown-list-icon-size: 25px;
}
.game-filter-bg {
  background: var(--background1) !important;
}
.whitespace-nowrap {
  color: var(--text);
  margin-left: 5px;
}
@keyframes fadeInRight {
  from {
    opacity: 0;
    transform: translateX(300px);
  }
  to {
    opacity: 1;
  }
}
.search-box-wrapper {
  border-left: 2px solid var(--border);
  background: var(--background1);
  // box-shadow: 0px 0px 20px 0px rgba(0, 0, 0, 0.50);
  box-shadow: -20px 0px 49px -10px rgba(0, 0, 0, 0.5);
  animation: fadeInRight 1s ease-in-out;
  padding-left: 16px;
  height: 53px;
  display: flex;
  align-items: center;
}
.search-box {
  width: var(--search-width);
  height: var(--search-height);
  font-size: var(--search-font-size);
  border: 1px solid var(--text);
  border-radius: var(--search-box-radius);
  border-radius: 5px;
  padding: 0px 16px;

  .el-input__inner {
    background-color: transparent;
    border: none !important;
    outline: none;
    height: calc(var(--search-height) / 2);
    box-shadow: none;
    color: var(--text);
    padding: 0;
  }
}
.game-tab-menu {
  position: relative;
  color: var(--gf-text-color);

  .icon {
    fill: var(--text);
    width: var(--game-tab-img-size);
    height: var(--game-tab-img-size);
  }
  span {
    font-size: var(--tab-font-size);
  }
}
.game-tab-menu:hover,
.active-tab {
  background: var(--secondary);
  .icon {
    fill: var(--text5);
  }
  span {
    color: var(--text5);
  }
  .game-drop-down {
    display: block;
  }
}
.theme-wrapper[theme-color="main_lightblue"] .game-tab-menu:hover,
.active-tab {
  background: var(--secondary);
  .icon {
    fill: var(--text5);
  }
  span {
    color: var(--text5) !important;
  }
  .game-drop-down {
    display: block;
  }
}
.theme-wrapper[theme-color="main_lightblue"] .divide-y .menu-sitebar {
  border-bottom: 1px #243c5a solid;
}
.game-drop-down {
  padding: 0px;
  z-index: 20 !important;
  .el-popper__arrow {
    &::before {
      background: var(--gf-background-color) !important;
      border: var(--gf-background-color) !important;
    }
  }
}
.drop-content {
  display: flex;
  flex-direction: column;
  color: var(--dropdown-text-color);
  min-width: var(--dropdown-min-width);
}
.drop-down-list {
  padding: 0 2px 3px 2px;
  width: 100%;
  font-size: var(--dropdown-font-size);

  .is-new {
    // background-color: var(--new-background-color);
    padding: 0 5px;
    font-size: var(--new-font-size);
    color: var(--new-text-color);
    height: fit-content;
    border-radius: 3px;
    img {
      width: 48px;
      height: 16px;
    }
  }
  .is-promotion {
    background-color: var(--promotion-background-color);
    padding: 0 5px;
    font-size: var(--promotion-font-size);
    color: var(--promotion-text-color);
    height: fit-content;
    border-radius: 3px;
  }

  img {
    width: var(--dropdown-list-icon-size);
    height: var(--dropdown-list-icon-size);
  }
}
.drop-down-list:hover span,
.active span {
  font-weight: 700;
}
.entry__buttons-container {
  width: 100%;
  height: max-content;
  display: flex;
  background: var(--background1);
  border-radius: 8px;
}
.entry__buttons {
  position: relative;
  max-width: 1200px;
  width: 100%;
  gap: 16px 8px;
  display: flex;
  align-items: center;
  flex-wrap: wrap;
}
</style>

<style scoped lang="scss">
.search-game-form {
  :deep(.el-input__wrapper) {
    padding-right: 22px;
  }
  :deep(.search-game-button) {
    position: absolute;
    top: 50%;
    transform: translateY(-50%);
    right: 22px;
    height: 28px;
    width: 28px;
  }
  :deep(.search-button) {
    min-width: 15%;
    // color: var(--text) !important;
  }
  :deep(.el-input__inner::placeholder) {
    color: var(--text);
    opacity: 1;
  }

  :deep(.el-input__inner::-ms-input-placeholder) {
    color: var(--text);
  }
}
.black-flexible1-customize .grid .flex .flex span.fc-primary {
  color: var(--primary);
}
</style>
